#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System.Collections.Generic;
using HeuristicLab.Collections;

namespace HeuristicLab.Core {
  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("F6D65667-A61A-44FB-B8FD-48F69EC9634B")]
  public interface ICheckedItemList<T> : IItemList<T> where T : class, IItem {
    event CollectionItemsChangedEventHandler<IndexedItem<T>> CheckedItemsChanged;
    IEnumerable<IndexedItem<T>> CheckedItems { get; }
    bool ItemChecked(T item);
    void SetItemCheckedState(T item, bool checkedState);
    void Add(T item, bool checkedState);
    void Insert(int index, T item, bool checkedState);
  }
}
